import 'package:libac_dart/nbt/Stream.dart';
import 'package:libac_dart/nbt/Tag.dart';
import 'package:libac_dart/nbt/impl/CompoundTag.dart';
import 'package:libac_dart/packets/packets.dart';

void main() async {
  PacketRegistry reg = PacketRegistry();
  reg.registerDefaults();

  PacketClient client = PacketClient();
  await client.startConnect("127.0.0.1", 25306);

  S2CResponse response = await client.send(C2SPing(), true);
  CompoundTag tag = response.contents;
  StringBuilder builder = StringBuilder();
  Tag.writeStringifiedNamedTag(tag, builder, 0);

  print("Response from server: \n${builder}");

  await client.send(StopServerPacket(), false);

  if (client.connected) await client.close();
  return;
}
