import 'package:libac_dart/argparse/Args.dart';

class BoolArgument extends Argument<bool> {
  bool _value = false;
  bool _hasValue = true;

  BoolArgument({required super.name, bool? value = true}) {
    if (value != null)
      this._value = value;
    else
      _hasValue = false;
  }

  @override
  ArgumentType getType() {
    return ArgumentType.BOOL;
  }

  @override
  bool getValue() {
    return _value;
  }

  @override
  String toString() {
    return "BooleanArgument{ ${name}=${_value} }";
  }

  @override
  bool hasValue() {
    return _hasValue;
  }
}
