import 'package:libac_dart/argparse/Args.dart';

class IntegerArgument extends Argument<int> {
  int _value = 0;
  bool _hasValue = false;

  IntegerArgument({required super.name, int? value}) {
    if (value != null) {
      this._value = value;
      _hasValue = true;
    } else
      _hasValue = false;
  }

  @override
  bool hasValue() {
    return _hasValue;
  }

  @override
  int getValue() {
    return _value;
  }

  @override
  ArgumentType getType() {
    return ArgumentType.INTEGER;
  }

  @override
  String toString() {
    return "IntegerArgument{ ${name}=${_value} }";
  }
}

class DoubleArgument extends Argument<double> {
  double _value = 0.0;
  bool _hasValue = false;

  DoubleArgument({required super.name, double? value}) {
    if (value != null) {
      _hasValue = true;
      _value = value;
    } else
      _hasValue = false;
  }

  @override
  bool hasValue() {
    return _hasValue;
  }

  @override
  ArgumentType getType() {
    return ArgumentType.DOUBLE;
  }

  @override
  double getValue() {
    return _value;
  }

  @override
  String toString() {
    return "DoubleArgument{ ${name}=${_value} }";
  }
}
