import 'package:libac_dart/argparse/Args.dart';

class StringArgument extends Argument<String> {
  String _value = "";
  bool _hasValue = false;

  StringArgument({required super.name, String? value}) {
    if (value != null) {
      _hasValue = true;
      _value = value;
    } else
      _hasValue = false;
  }

  @override
  bool hasValue() {
    return _hasValue;
  }

  @override
  String getValue() {
    return _value;
  }

  @override
  ArgumentType getType() {
    return ArgumentType.STRING;
  }

  @override
  String toString() {
    return "StringArgument{ ${name}=${_value} }";
  }
}
