import 'package:dio/dio.dart';

/// Contains currently supported endpoints and URLs.
class DiscordEndpoints {
  /// Currently this is set to 10
  static const APIVersion = 10;

  /// This is the current base URL of all discord API calls per reference.
  static const BaseURL = "https://discord.com/api/v${APIVersion}";
  static const ME = "/@me";
  static const Applications = "/applications";
  static const Users = "/users";
  static const Stickers = "/stickers";
  static const StickerPacks = "/sticker-packs";
  static const Guilds = "/guilds";
}

class DiscordSessionSettings {
  static String BOT_TOKEN = "";

  static BaseOptions get getOptions => BaseOptions(
      headers: {"Authorization": "Bot ${DiscordSessionSettings.BOT_TOKEN}"});
}
