enum CommunicationType {
  /// Whispers can be heard up to 10m away
  Whisper,

  /// Normal chat can be heard up to 20m away
  Say,

  /// Shouts can be heard up to 100m away
  Shout,

  /// Indicates the message can only be heard by the object owner within the same simulator
  OwnerSay,

  /// The message can be heard anywhere within the same simulator
  /// Channel 0 is restricted and cannot be used to broadcast
  RegionSay,

  /// The message can be heard anywhere within the same simulator by the designated recipient.
  RegionSayTo
}
