class Key {
  String _value;

  // Getter and setter for `guid`
  String get guid {
    _value ??= '';
    return _value;
  }

  set guid(String value) {
    _value = value;
  }

  // Constructors
  Key.fromGuid(String guid) : _value = guid;

  Key.fromString(String strGuid) : _value = strGuid;

  // NULL_KEY equivalent
  static final Key NULL_KEY =
      Key.fromString("00000000-0000-0000-0000-000000000000");

  // Implicit conversion from String to Key
  factory Key.fromStringOrNull(String? strGuid) {
    return strGuid == null ? Key.fromString('') : Key.fromString(strGuid);
  }

  // Implicit conversion to String
  @override
  String toString() {
    return guid;
  }

  // Equality operator
  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is Key && other.guid == guid;
  }

  @override
  int get hashCode => guid.hashCode;

  // Boolean logic
  bool isTrue() {
    return !(guid == NULL_KEY.guid || guid.isEmpty);
  }

  bool isFalse() {
    return !isTrue();
  }

  @override
  bool equals(Object obj) {
    if (identical(this, obj)) return true;

    return obj is Key && this == obj;
  }
}
