class string {
  String value = "";

  string(dynamic value) {
    if (value is String)
      this.value = value;
    else
      this.value = value;
  }

  // Implicit conversion from String to CustomString
  string.fromString(String s) : value = s;

  // Explicit conversions
  /// This handler in the original C# code had this note:
  /// // 3 oct 2007
  string.fromBool(bool a) : value = a ? "1" : "0";

  /// This handler in the original C# code had this note:
  /// // 24 augustus 2007
  string.fromInt(int i) : value = i.toString();

  string.fromLong(int i) : value = i.toString();

  string.fromFloat(double i) : value = i.toStringAsFixed(6);

  // Implicit conversion from CustomString to String
  String toString() => value ?? '';

  // Conversion to bool
  bool toBool() => value.isNotEmpty;

  // Equality operator
  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is string && other.value == value;
  }

  @override
  int get hashCode => value.hashCode;

  @override
  bool equals(Object other) {
    if (identical(this, other)) return true;

    return other is string && other.value == value;
  }
}
