import 'dart:typed_data';

import 'package:libac_dart/nbt/Stream.dart';
import 'package:libac_dart/utils/Hashing.dart';
import 'package:test/expect.dart';
import 'package:test/scaffolding.dart';

void main() {
  test("Test md5", () {
    expect(Hashing.md5Hash("Hello World"), "b10a8db164e0754105b7a99be72e3fe5");
  });

  test("Test sha256", () {
    Uint8List hsh = Uint8List.fromList(Hashing.sha256Sum([0x0A, 0x0B]));
    print("Sha256 Length: ${hsh.lengthInBytes}");

    ByteLayer layer = ByteLayer();
    layer.writeBytes(hsh);
    print("Layer length: ${layer.bytes.lengthInBytes}");

    print("Sha256 Hash: ${Hashing.bytes2Hash(hsh)}");

    expect(Hashing.bytes2Hash(hsh),
        "bea0b72e71bfe7f15a88c25305bf96a9681e34d3aabe0c9a1b7093cb32d8ff05");
  });
}
